import ast
import numpy as np
import pandas as pd
import matplotlib
matplotlib.use('agg')
import matplotlib.pyplot as plt
from matplotlib.ticker import AutoLocator
import scipy.stats as stats
import math
matplotlib.rcParams['pdf.fonttype'] = 42
matplotlib.rcParams['ps.fonttype'] = 42

w1_NLP = pd.read_csv('results/w0=(0,1)_NLP_w.csv',header=None,delimiter='\t').values;
w2_NLP = pd.read_csv('results/w0=(0,2.5)_NLP_w.csv',header=None,delimiter='\t').values;
w3_NLP = pd.read_csv('results/w0=(-1.5,0.5)_NLP_w.csv',header=None,delimiter='\t').values;

w1_CNLP = pd.read_csv('results/w0=(0,1)_CNLP_w.csv',header=None,delimiter='\t').values;
w2_CNLP = pd.read_csv('results/w0=(0,2.5)_CNLP_w.csv',header=None,delimiter='\t').values;
w3_CNLP = pd.read_csv('results/w0=(-1.5,0.5)_CNLP_w.csv',header=None,delimiter='\t').values;

w1_GREEDY = pd.read_csv('results/w0=(0,1)_GREEDY_w.csv',header=None,delimiter=',').values;
w2_GREEDY = pd.read_csv('results/w0=(0,2.5)_GREEDY_w.csv',header=None,delimiter=',').values;
w3_GREEDY = pd.read_csv('results/w0=(-1.5,0.5)_GREEDY_w.csv',header=None,delimiter=',').values;

w1_STRAIGHT = pd.read_csv('results/w0=(0,1)_STRAIGHT_w.csv',header=None,delimiter=',').values;
w2_STRAIGHT = pd.read_csv('results/w0=(0,2.5)_STRAIGHT_w.csv',header=None,delimiter=',').values;
w3_STRAIGHT = pd.read_csv('results/w0=(-1.5,0.5)_STRAIGHT_w.csv',header=None,delimiter=',').values;

fig = plt.figure(figsize=(6.7513,2.2))

plt.subplot(131)

w0 = [0,1]
plt.grid()

plt.plot(w1_GREEDY[0,:], w1_GREEDY[1,:], '-', linewidth=1, label = 'GREEDY, T='+str(len(w1_GREEDY[0,:])-1))
plt.plot(w1_STRAIGHT[0,:], w1_STRAIGHT[1,:], '-', linewidth=1, label = 'STRAIGHT, T='+str(len(w1_STRAIGHT[0,:])-1))
plt.plot(w1_NLP[0,:], w1_NLP[1,:], '-', linewidth=2.0, label = 'NLP, T='+str(len(w1_NLP[0,:])-1))
plt.plot(w1_CNLP[:,0], w1_CNLP[:,1], '--', linewidth=1, label = 'CNLP, $t_f$ =1.52s')
plt.plot(w0[0],w0[1], 'ko', markersize=3, label = '', zorder=10)
plt.plot(1,0, 'k*',markersize=6, markeredgewidth=0, label = '', zorder=10)
plt.legend(loc="lower left",fontsize="x-small")   # make legend text smaller
plt.xticks(fontsize=6)
plt.yticks(fontsize=6)
plt.axis("equal")
plt.xlim(xmax = 1.1)
plt.xlim(xmin = -0.1)
plt.ylim(ymax = 1.1)
plt.ylim(ymin = -0.1)



plt.subplot(132)

w0 = [0,2.5]
plt.grid()
plt.plot(w0[0],w0[1], 'ko', markersize=3, label = '$w_0$', zorder=10)
plt.plot(1,0, 'k*',markersize=6, markeredgewidth=0, label = '$w_\star$', zorder=10)
plt.plot(w2_GREEDY[0,:], w2_GREEDY[1,:], '-', linewidth=1, label = 'GREEDY, T='+str(len(w2_GREEDY[0,:])-1))
plt.plot(w2_STRAIGHT[0,:], w2_STRAIGHT[1,:], '-', linewidth=1, label = 'STRAIGHT, T='+str(len(w2_STRAIGHT[0,:])-1))
plt.plot(w2_NLP[0,:], w2_NLP[1,:], '-', linewidth=2.0, label = 'NLP, T='+str(len(w2_NLP[0,:])-1))
plt.plot(w2_CNLP[:,0], w2_CNLP[:,1], '--', linewidth=1, label = 'CNLP, $t_f$ =1.53s')

plt.legend(loc="lower left",fontsize="x-small")   # make legend text smaller
plt.xticks(fontsize=6)
plt.yticks(fontsize=6)
plt.axis("equal")
plt.xlim(xmax = 1.2)
plt.xlim(xmin = -1.5)
plt.ylim(ymax = 2.6)
plt.ylim(ymin = -0.1)


plt.subplot(133)

w0 = [-1.5,0.5]
plt.grid()
plt.plot(w3_GREEDY[0,:], w3_GREEDY[1,:], '-', linewidth=1, label = 'GREEDY, T='+str(len(w3_GREEDY[0,:])-1))
plt.plot(w3_STRAIGHT[0,:], w3_STRAIGHT[1,:], '-', linewidth=1, label = 'STRAIGHT, T='+str(len(w3_STRAIGHT[0,:])-1))
plt.plot(w3_NLP[0,:], w3_NLP[1,:], '-', linewidth=2.0, label = 'NLP, T='+str(len(w3_NLP[0,:])-1))
plt.plot(w3_CNLP[:,0], w3_CNLP[:,1], '--', linewidth=1, label = 'CNLP, $t_f$ =2.59s')
plt.plot(w0[0],w0[1], 'ko', markersize=3, label = '', zorder=10)
plt.plot(1,0, 'k*',markersize=6, markeredgewidth=0, label = '', zorder=10)
plt.legend(loc="lower left",fontsize="x-small")   # make legend text smaller
plt.xticks(fontsize=6)
plt.yticks(fontsize=6)
plt.axis("equal")
plt.xlim(xmax = 1.1)
plt.xlim(xmin = -1.6)
plt.ylim(ymax = 1.6)
plt.ylim(ymin = -1.1)

plt.tight_layout(pad=0) 
fig.savefig('../figures/w_combined_no_type3.pdf')
plt.close()


